define([
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/CheckBox",
    "dijit/form/RadioButton",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dom-construct",
    "dojo/text!./templates/MultipleChoiceInputWidget.html"
], function(_Container, _TemplatedMixin, _WidgetBase, _WidgetsInTemplateMixin, CheckBox, RadioButton, array, declare, domConstruct, template) {
    return declare([_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_Container],{
        templateString: template,
        startup: function() {
            if ( this._started ) { return; }
            this.inherited(arguments);

            domConstruct.empty(this.domNode);
            var Ctor = this.allowMultiple === true ? CheckBox : RadioButton;
            array.forEach(this.items, function(item){
                var div = domConstruct.create("div", {
                }, this.domNode, "last");
                var input = new Ctor({
                    name: this.code + (this.allowMultiple === true ? item.subcode : ''),
                    value: this.allowMultiple === true ? null : item.subcode
                }).placeAt(div);
                var label = domConstruct.create("label",{
                    'for': input.id,
                    innerHTML: item.text
                }, div);
            }, this);
        }
    });
});
