define([
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/RadioButton",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/text!./templates/ScaleInputWidget.html"
], function(_Container, _TemplatedMixin, _WidgetBase, _WidgetsInTemplateMixin, RadioButton, array, declare, lang, domAttr, domConstruct, template) {
    return declare([_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_Container],{
        templateString: template,
        baseClass: "qedScaleWidget",
        startup: function() {
            if ( this._started ) { return; }
            this.inherited(arguments);
            this._renderHead();
            this._renderItems();
        },
        _renderHead: function() {
            this.minNode.innerHTML = this.minLabel || "";
            this.maxNode.innerHTML = this.maxLabel || "";
            if ( this.naLabel !== null ) {
                this.naNode.innerHTML = this.naLabel;
            }
            for (var i = this.min; i <= this.max; i++) {
                domConstruct.create("th", {
                    innerHTML: i.toString()
                }, this.maxNode, "before");
            }
        },
        _renderItems: function() {
            array.forEach(this.items, function(item) {
                var tr = domConstruct.create("tr", {}, this.itemsNode);
                var td;
                var radio;
                domConstruct.create("th", {
                    innerHTML: item.text || "",
                    'class': "item"
                }, tr);
                domConstruct.create("th", {
                    innerHTML: item.minLabel || "",
                    'class': 'min'
                }, tr);
                for (var i = this.min; i <= this.max; i++) {
                    td = domConstruct.create("td", {}, tr);
                    radio = new RadioButton({
                        name: this.code+item.subcode,
                        value: i.toString()
                    });
                    domConstruct.place(radio.domNode, td); 
                }
                domConstruct.create("th", {
                    innerHTML: item.maxLabel || "",
                    className: 'max'
                }, tr);
                if ( this.naLabel !== null && this.naLabel !== "" ) {
                    td = domConstruct.create("td", {}, tr);
                    radio = new RadioButton({
                        name: this.code+item.subcode,
                        value: "n/a"
                    });
                    domConstruct.place(radio.domNode, td); 
                }
            }, this);
        }
    });
});
