var env = require('../env')
  , upgradeCouch = require('../config/upgrade-couchdb')
  , cryptoken = require('../util/crypto-token')
  , Q = require('q')
  , _ = require('underscore')
  ;

function flatten(obj,prefix,newObj) {
    prefix = prefix || "";
    newObj = newObj || {};
    _.each(obj,function(val,key){
        key = key.replace(/^[0-9]+\//,'');
        if ( _.isObject(val) && !_.isArray(val) ) {
            flatten(val,prefix+key,newObj);
        } else {
            newObj[prefix+key] = val;
        }
    });
    return newObj;
}

upgradeCouch(env.couchServerURL,env.dbName,function(doc){
    if ( doc.type === "Response" ) {
        doc.answers = flatten(doc.answers);
        return doc;
    } else {
        return Q.reject();
    }
}).then(function(res){
    console.log("done",res);
}, function(err){
    console.error("fail",err);
});
